SystemOrganization addCategory: #'CT-Monticello-Tests'!

TestCase subclass: #CtMonticelloTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CT-Monticello-Tests'!

!CtMonticelloTest class methodsFor: 'marking' stamp: 'cs 5/4/2009 02:05'!
markCollection: anAttribute

	| source ref |
	ref := MethodReference class: Collection selector: #do:.
	source := ref sourceCode.
	(source attributesOfKind: XpfComplexAttribute)
		do: [:att | source removeAttribute: att ].
	source addAttribute: anAttribute from: 1 to: 1.
	Collection compile: source classified: ref category.
	^ ref! !

!CtMonticelloTest class methodsFor: 'marking' stamp: 'mt 5/5/2009 15:05'!
markCollectionDoBad
	^ self markCollection: (XpfComplexAttribute forTag: #bad)! !

!CtMonticelloTest class methodsFor: 'marking' stamp: 'cs 5/2/2009 12:58'!
markCollectionDoNormal

	| source ref |
	ref := MethodReference class: Collection selector: #do:.
	source := ref sourceCode.
	Collection compile: source asString classified: ref category.
	^ ref! !

!CtMonticelloTest methodsFor: 'tests' stamp: 'mt 5/5/2009 15:05'!
testAddCodeMarkup
	| ref source md snapshotBin md2 color |
	ref := self class markCollectionDoBad.
	source := ref sourceCode.
	color := ((source attributesAt: 1) detect: [ :attr | attr isKindOf: XpfComplexAttribute ]) color.
	md := (Collection compiledMethodAt: #do:) methodReference asMethodDefinition.
	snapshotBin := MCMczWriter new serializeInBinary: (MCSnapshot fromDefinitions: {  md  }).
	md2 := (DataStream on: ((RWBinaryOrTextStream with: snapshotBin)
			reset;
			yourself)) next definitions first.
	self
		should: md2 source isString;
		should: md2 sourceText isText;
		should: md source = md2 source;
		should: ((md2 sourceText attributesAt: 1) anySatisfy: [ :attr | (attr isKindOf: XpfComplexAttribute) and: [ attr color = color ] ]).

	"Clean up"
	self class markCollectionDoNormal! !

!CtMonticelloTest methodsFor: 'tests' stamp: 'mig 5/25/2010 13:47:46.048'!
testDefinitionFromReference

	| ref cm md |
	ref := MethodReference class: Collection selector: #do:.
	cm := Collection compiledMethodAt: #do:.
	md := ref asMethodDefinition.
	
	self
		should: cm getSource = ref sourceCode;
		should: ref sourceCode isText;
		should: ref source isString;
		should: md source isString.! !

!MCVersion methodsFor: '*ct-monticello-override' stamp: 'mt 9/22/2010 15:52:21.984'!
load

	MCVersionLoader loadVersion: self.
	
	CtMarkupDatabase local merge: self markups.
	
	"(Preferences
		preferenceAt: #browseMarkupsAfterLoadMerge
		ifAbsent: [Preference new rawValue: false])
		preferenceValue ifTrue: [ CtMarkupBrowser
			openOn: (OBClassCategoryNode on: self package name)]."! !

!MCVersion methodsFor: '*ct-monticello' stamp: 'mt 1/17/2010 22:05'!
markups

	^ markups! !

!MCVersion methodsFor: '*ct-monticello' stamp: 'mt 1/17/2010 22:06'!
markups: aMarkupDatabase

	markups := aMarkupDatabase! !

!MCVersion methodsFor: '*ct-monticello-override' stamp: 'mt 3/18/2010 18:57:39'!
merge

	MCVersionMerger mergeVersion: self.
	
	CtMarkupDatabase local merge: self markups.
	
	"Need MC package node support!!"
	"(Preferences
		preferenceAt: #browseMarkupsAfterLoadMerge
		ifAbsent: [Preference new rawValue: false])
		preferenceValue ifTrue: [ CtMarkupBrowser
			openOn: (OBMonticelloPackageNode on: self package workingCopy)]."! !

!MCMczWriter methodsFor: '*ct-monticello' stamp: 'mt 1/17/2010 21:47'!
writeMarkups: aPackageName

	self addString: (self serializeInBinary: (CtMarkupDatabase local snapshot: aPackageName)) at: 'markups.bin'! !

!MCMczWriter methodsFor: '*ct-monticello-override' stamp: 'mt 1/22/2010 13:21:06'!
writeVersion: aVersion
	"Override to write markups."

	SwaSourceTextStyler instance disable.

	self writeFormat.
	self writePackage: aVersion package.
	self writeVersionInfo: aVersion info.
	self writeDefinitions: aVersion.
	self writeMarkups: aVersion package name.
	aVersion dependencies do: [:ea | self writeVersionDependency: ea].
	
	SwaSourceTextStyler instance enable.! !

!MCMczReader methodsFor: '*ct-monticello' stamp: 'mt 1/17/2010 22:08'!
basicVersion

	^ super basicVersion
		markups: self markups! !

!MCMczReader methodsFor: '*ct-monticello' stamp: 'mt 1/17/2010 22:13'!
loadMarkups

	(self zip memberNamed: 'markups.bin') ifNotNilDo:
		[:m | [markups := (DataStream on: m contentStream) next]
			on: Error do: [:fallThrough ]].! !

!MCMczReader methodsFor: '*ct-monticello' stamp: 'mt 1/17/2010 22:15'!
markups

	markups ifNil: [self loadMarkups].
	^ markups! !
